
/* See file "monitor.c" for copyright and other information. */

#include <stdio.h>
//#include <stdlib.h>
//#include <malloc.h>
#include <math.h>
#include <time.h>
#include <sys/timeb.h>
#include <windows.h>
//#include <wingdi.h>
//#include <winuser.h>
#include <process.h>
#include "resource.h"
#include "globals.h"


#if defined (WIN32)
	#define IS_WIN32	TRUE
#else
	#define IS_WIN32	FALSE
#endif

#define IS_NT	IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S	IS_WIN32 && (BOOL)(!(IS_NT) && \
					(LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95	(BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32


HINSTANCE				hInst;						// current instance
char	textout[MAX_FILENAME_CHARS];
int		START_AT_RUNTIME;							// if run in background mode

LPCTSTR lpszTitle="Ameter Analyzer";

BOOL RegisterWin95(CONST WNDCLASS* lpwc);



int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				LPTSTR lpCmdLine, int nCmdShow)

{
MSG			msg;
HWND		hWnd;
WNDCLASS	wc;
FILE		*fpt;
SECURITY_ATTRIBUTES SharedMemoryAttributes;
HMENU		hMenu;
char		text[80];
int			i;



wc.style=CS_HREDRAW | CS_VREDRAW;
wc.lpfnWndProc=(WNDPROC)WndProc;
wc.cbClsExtra=0;
wc.cbWndExtra=0;
wc.hInstance=hInstance;
wc.hIcon=LoadIcon(hInstance,"ID_AMETER_ICON");
wc.hCursor=LoadCursor(NULL,IDC_ARROW);
wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
wc.lpszMenuName="ID_MAIN_MENU";
wc.lpszClassName="AMETER";

if (IS_WIN95)
  {
  if (!RegisterWin95(&wc))
    return(FALSE);
  }
else if (!RegisterClass(&wc))
  return(FALSE);

hInst=hInstance;

hWnd=CreateWindow("AMeter",lpszTitle,
		WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL | WS_MAXIMIZE,
		CW_USEDEFAULT,0,800,600,NULL,NULL,hInstance,NULL);
if (!hWnd)
  return(FALSE);

ShowScrollBar(hWnd,SB_BOTH,FALSE);
if (strcmp(lpCmdLine,"-background") == 0)
  {
  ShowWindow(hWnd,SW_MINIMIZE);
  START_AT_RUNTIME=1;
  }
else
  {
  ShowWindow(hWnd,SW_MAXIMIZE /* nCmdShow */);
  START_AT_RUNTIME=0;
  }
UpdateWindow(hWnd);
MainWnd=hWnd;

strcpy(CurrentPath,"C:\\Data\\");
i=GetFileAttributes(CurrentPath);
strcpy(ParamsFilename,"C:\\Data\\Defaults.txt");
if (i < 0  ||  !(i & FILE_ATTRIBUTE_DIRECTORY))
  if (CreateDirectory(CurrentPath,NULL) == FALSE)
	{
    MessageBox(NULL,"Unable to create folder for saving data.\nPlease create this folder and restart.",
				CurrentPath,MB_OK | MB_APPLMODAL);
    exit(0);
	}

Minutes=0;
TotalMinutes=0;
MeanRSA=StdDevRSA=0.0;
CalibrationLocked=0;
UseCorrectionEngine=1;	/* default is on */

MonitorOn=0;
PlaybackSpeed=1;
DisplayMode=1;	  /* normal details display */

if ((fpt=fopen(ParamsFilename,"r")) == NULL)
  {
//  MessageBox(NULL,"Unable to open default parameters file",ParamsFilename,MB_OK | MB_APPLMODAL);
  HeartRateWindowRows=200;
  HeartRateWindowCols=300;
  PowerWindowRows=150;
  PowerWindowCols=150;
  RSAWindowRows=150;
  RSAWindowCols=300;
  RSALongWindowRows=150;
  RSALongWindowCols=HeartRateWindowCols+SIDE_WINDOW_MARGIN+RSAWindowCols;
  NormWindowRows=150;
  NormWindowCols=150;
  PlotDataMinValue=200;
  PlotDataMaxValue=1500;
  PlotDataRange=60;
  PowerDataMinValue=0;
  PowerDataMaxValue=SQR(1000)/(30*60);
  PowerDataRange=30;
  RSADataRange=60;		/* units are seconds */
  RSALongDataRange=120;	/* units are minutes */
  NormDistMinValue=-3;
  NormDistMaxValue=+7;

  SamplingRate=4;
  WindowSec=64;
  WindowSize=256;
  ArousalSmooth=1.0;
  ZScoreRange=1.5;

  Save_Cor_aIBI=0;
  }
else
  {
  fscanf(fpt,"HeartRateWindowRows %d\n",&HeartRateWindowRows);
  fscanf(fpt,"HeartRateWindowCols %d\n",&HeartRateWindowCols);
  fscanf(fpt,"PowerWindowRows %d\n",&PowerWindowRows);
  fscanf(fpt,"PowerWindowCols %d\n",&PowerWindowCols);
  fscanf(fpt,"RSAWindowRows %d\n",&RSAWindowRows);
  fscanf(fpt,"RSAWindowCols %d\n",&RSAWindowCols);
  fscanf(fpt,"RSALongWindowRows %d\n",&RSALongWindowRows);
  fscanf(fpt,"RSALongWindowCols %d\n",&RSALongWindowCols);
  fscanf(fpt,"NormWindowRows %d\n",&NormWindowRows);
  fscanf(fpt,"NormWindowCols %d\n",&NormWindowCols);
  fscanf(fpt,"PlotDataMinValue %d\n",&PlotDataMinValue);
  fscanf(fpt,"PlotDataMaxValue %d\n",&PlotDataMaxValue);
  fscanf(fpt,"PlotDataRange %d\n",&PlotDataRange);
  fscanf(fpt,"PowerDataMinValue %d\n",&PowerDataMinValue);
  fscanf(fpt,"PowerDataMaxValue %d\n",&PowerDataMaxValue);
  fscanf(fpt,"PowerDataRange %d\n",&PowerDataRange);
  fscanf(fpt,"RSADataRange %d\n",&RSADataRange);
  fscanf(fpt,"RSALongDataRange %d\n",&RSALongDataRange);
  fscanf(fpt,"NormDistMinValue %d\n",&NormDistMinValue);
  fscanf(fpt,"NormDistMaxValue %d\n",&NormDistMaxValue);
  fscanf(fpt,"SamplingRate %d\n",&SamplingRate);
  fscanf(fpt,"WindowSec %d\n",&WindowSec);
  fscanf(fpt,"WindowSize %d\n",&WindowSize);
  fscanf(fpt,"%s %lf\n",text,&ArousalSmooth);
  if (strcmp(text,"ArousalSmooth") != 0)  /* this position used to be power averaging */
	ArousalSmooth=1.0;
  fscanf(fpt,"ZScoreRange %lf\n",&ZScoreRange);
  fscanf(fpt,"Save_Cor_aIBI %d\n",&Save_Cor_aIBI);
  fclose(fpt);
  hMenu=GetMenu(hWnd);
  if (Save_Cor_aIBI == 0)
    CheckMenuItem(hMenu,ID_SAVE_COR,MF_UNCHECKED);
  else
    CheckMenuItem(hMenu,ID_SAVE_COR,MF_CHECKED);
  }

		/* open up memory-mapped object (using the system pagefile) to stream ameter readings */
SharedMemoryAttributes.bInheritHandle=TRUE;
SharedMemoryAttributes.lpSecurityDescriptor=NULL;
SharedMemoryAttributes.nLength=sizeof(SECURITY_ATTRIBUTES);
SharedMemoryHandle=CreateFileMapping((HANDLE)0xffffffff,&SharedMemoryAttributes,PAGE_READWRITE,
									 0,1024,"AMeterGauge");
if (SharedMemoryHandle != NULL  &&  GetLastError() == ERROR_ALREADY_EXISTS)
  {
  CloseHandle(SharedMemoryHandle);
  MessageBox(NULL,"Duplicate AMeter handle detected","Error - AMeter already running?",
					MB_OK | MB_APPLMODAL);
  exit(0);
  }
if (SharedMemoryHandle == NULL)
  {
  MessageBox(NULL,"Unabe to open AMeter shared memory handle;\nGauge unavailable to other processes",
					"Error",MB_OK | MB_APPLMODAL);
  }

if (START_AT_RUNTIME == 1)
  PostMessage(MainWnd,WM_COMMAND,ID_RUN_START,0);

InvalidateRect(hWnd,NULL,TRUE);
UpdateWindow(hWnd);

while (GetMessage(&msg,NULL,0,0))
  {
  TranslateMessage(&msg);
  DispatchMessage(&msg);
  }
return(msg.wParam);
}



BOOL RegisterWin95(CONST WNDCLASS* lpwc)

{
WNDCLASSEX wcex;

wcex.style=lpwc->style;
wcex.lpfnWndProc=lpwc->lpfnWndProc;
wcex.cbClsExtra=lpwc->cbClsExtra;
wcex.cbWndExtra=lpwc->cbWndExtra;
wcex.hInstance=lpwc->hInstance;
wcex.hIcon=lpwc->hIcon;
wcex.hCursor=lpwc->hCursor;
wcex.hbrBackground=lpwc->hbrBackground;
wcex.lpszMenuName=lpwc->lpszMenuName;
wcex.lpszClassName=lpwc->lpszClassName;
		// Added elements for Windows 95:
wcex.cbSize=sizeof(WNDCLASSEX);
wcex.hIconSm=LoadIcon(wcex.hInstance,"ID_AMETER_ICON");
wcex.hIcon=LoadIcon(wcex.hInstance,"ID_AMETER_ICON");
return (RegisterClassEx(&wcex));
}



LRESULT CALLBACK WndProc (HWND hWnd, UINT uMsg,
		WPARAM wParam, LPARAM lParam)

{
HMENU			hMenu;
FILE			*fpt;
OPENFILENAME	ofn;
char			text1[320],text2[160];

switch (uMsg)
  {
  case WM_COMMAND:
    switch (LOWORD(wParam))
      {
	  case ID_RUN_START:
		if (MonitorOn == 1)
		  break;
		hMenu=GetMenu(hWnd);
		CheckMenuItem(hMenu,ID_TEST_SIGNAL,MF_UNCHECKED);
		CheckMenuItem(hMenu,ID_RUN_START,MF_CHECKED);
		CheckMenuItem(hMenu,ID_RUN_PLAYBACK,MF_UNCHECKED);
		AnalysisMode=0;
		MonitorOn=1;
		_beginthread(Monitor,0,hWnd);
		break;
	  case ID_STOP:
		hMenu=GetMenu(hWnd);
		CheckMenuItem(hMenu,ID_TEST_SIGNAL,MF_UNCHECKED);
		CheckMenuItem(hMenu,ID_RUN_START,MF_UNCHECKED);
		CheckMenuItem(hMenu,ID_RUN_PLAYBACK,MF_UNCHECKED);
		MonitorOn=0;
		break;
	  case ID_VARS_ANALYSIS:
		DialogBox(hInst,"ID_ANALYSIS_PARAM_DIALOG",hWnd,(DLGPROC)AnalysisParamsProc);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		PaintImage();
		break;
	  case ID_VARS_DISPLAY:
		DialogBox(hInst,"ID_DISPLAY_PARAM_DIALOG",hWnd,(DLGPROC)DisplayParamsProc);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		PaintImage();
		break;
	  case ID_VARS_PLAYBACK:
		DialogBox(hInst,"ID_PLAYBACK_PARAM_DIALOG",hWnd,(DLGPROC)PlaybackParamsProc);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		PaintImage();
		break;
	  case ID_VARS_CORRECT_ENGINE:
		UseCorrectionEngine=(UseCorrectionEngine+1)%2;
		hMenu=GetMenu(hWnd);
		if (UseCorrectionEngine == 0)
		  CheckMenuItem(hMenu,ID_VARS_CORRECT_ENGINE,MF_UNCHECKED);
		else
		  CheckMenuItem(hMenu,ID_VARS_CORRECT_ENGINE,MF_CHECKED);
		break;
	  case ID_TEST_SIGNAL:
		if (MonitorOn == 1)
		  break;
		AnalysisMode=1;
		hMenu=GetMenu(hWnd);
		CheckMenuItem(hMenu,ID_TEST_SIGNAL,MF_CHECKED);
		CheckMenuItem(hMenu,ID_RUN_START,MF_UNCHECKED);
		CheckMenuItem(hMenu,ID_RUN_PLAYBACK,MF_UNCHECKED);
		MonitorOn=1;
		_beginthread(Monitor,0,hWnd);
		break;
	  case ID_RUN_PLAYBACK:
		if (MonitorOn == 1)
		  break;
		memset(&(ofn),0,sizeof(ofn));
		ofn.lStructSize=sizeof(ofn);
		ofn.lpstrFile=PlaybackFilename;
		PlaybackFilename[0]=0;
		ofn.nMaxFile=MAX_FILENAME_CHARS;
		ofn.Flags=OFN_EXPLORER;
		ofn.lpstrFilter = "Raw AMeter IBI files\0*-raw.txt\0All files\0*.*\0\0";
		SetCurrentDirectory(CurrentPath);
		if (!(GetOpenFileName(&ofn))  ||  PlaybackFilename[0] == '\0')
		  break;
		AnalysisMode=2;
		hMenu=GetMenu(hWnd);
		CheckMenuItem(hMenu,ID_TEST_SIGNAL,MF_UNCHECKED);
		CheckMenuItem(hMenu,ID_RUN_START,MF_UNCHECKED);
		CheckMenuItem(hMenu,ID_RUN_PLAYBACK,MF_CHECKED);
		MonitorOn=1;
		_beginthread(Monitor,0,hWnd);
		break;
	  case ID_SAVE_SETTINGS:
		if ((fpt=fopen(ParamsFilename,"w")) == NULL)
		  {
		  MessageBox(NULL,"Unable to open default parameters file",ParamsFilename,MB_OK | MB_APPLMODAL);
		  break;
		  }
        fprintf(fpt,"HeartRateWindowRows %d\n",HeartRateWindowRows);
	    fprintf(fpt,"HeartRateWindowCols %d\n",HeartRateWindowCols);
	    fprintf(fpt,"PowerWindowRows %d\n",PowerWindowRows);
	    fprintf(fpt,"PowerWindowCols %d\n",PowerWindowCols);
	    fprintf(fpt,"RSAWindowRows %d\n",RSAWindowRows);
	    fprintf(fpt,"RSAWindowCols %d\n",RSAWindowCols);
	    fprintf(fpt,"RSALongWindowRows %d\n",RSALongWindowRows);
	    fprintf(fpt,"RSALongWindowCols %d\n",RSALongWindowCols);
	    fprintf(fpt,"NormWindowRows %d\n",NormWindowRows);
	    fprintf(fpt,"NormWindowCols %d\n",NormWindowCols);
	    fprintf(fpt,"PlotDataMinValue %d\n",PlotDataMinValue);
		fprintf(fpt,"PlotDataMaxValue %d\n",PlotDataMaxValue);
		fprintf(fpt,"PlotDataRange %d\n",PlotDataRange);
		fprintf(fpt,"PowerDataMinValue %d\n",PowerDataMinValue);
		fprintf(fpt,"PowerDataMaxValue %d\n",PowerDataMaxValue);
		fprintf(fpt,"PowerDataRange %d\n",PowerDataRange);
		fprintf(fpt,"RSADataRange %d\n",RSADataRange);
		fprintf(fpt,"RSALongDataRange %d\n",RSALongDataRange);
		fprintf(fpt,"NormDistMinValue %d\n",NormDistMinValue);
		fprintf(fpt,"NormDistMaxValue %d\n",NormDistMaxValue);
		fprintf(fpt,"SamplingRate %d\n",SamplingRate);
		fprintf(fpt,"WindowSec %d\n",WindowSec);
		fprintf(fpt,"WindowSize %d\n",WindowSize);
		fprintf(fpt,"ArousalSmooth %lf\n",ArousalSmooth);
		fprintf(fpt,"ZScoreRange %lf\n",ZScoreRange);
		fprintf(fpt,"Save_Cor_aIBI %d\n",Save_Cor_aIBI);
		fclose(fpt);
		break;
	  case ID_CALIBRATE:
		if (MonitorOn == 1)
		  break;
		Minutes=TotalMinutes;
		DialogBox(hInst,"ID_POP_PARAM_DIALOG",hWnd,(DLGPROC)PopParamsProc);
		TotalMinutes=Minutes;
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_LOCK_CALIB:
		CalibrationLocked=(CalibrationLocked+1)%2;
		hMenu=GetMenu(hWnd);
		if (CalibrationLocked == 0)
		  CheckMenuItem(hMenu,ID_LOCK_CALIB,MF_UNCHECKED);
		else
		  CheckMenuItem(hMenu,ID_LOCK_CALIB,MF_CHECKED);
		break;
	  case ID_SAVE_COR:
		if (MonitorOn == 1)
		  break;
		Save_Cor_aIBI=(Save_Cor_aIBI+1)%2;
		hMenu=GetMenu(hWnd);
		if (Save_Cor_aIBI == 0)
		  CheckMenuItem(hMenu,ID_SAVE_COR,MF_UNCHECKED);
		else
		  CheckMenuItem(hMenu,ID_SAVE_COR,MF_CHECKED);
		break;
	  case ID_ABOUT:
		sprintf(text1,"AMeter version %s.  Copyright 2002-2005.\nClemson University (Adam Hoover, Eric Muth)",VersionText);
		sprintf(text2,"AMeter version %s.",VersionText);
		MessageBox(NULL,text1,text2,MB_OK | MB_APPLMODAL);
		break;
      case ID_EXIT:case ID_FILE_QUIT:
		MonitorOn=0;
		Sleep(100);
        DestroyWindow(hWnd);
		CloseHandle(SharedMemoryHandle);
        break;
	  default:
		break;
      }
    break;
  case WM_SIZE:
	if (hWnd != MainWnd  ||  GetUpdateRect(hWnd,NULL,FALSE) == 0)
	  {
      return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	  break;
	  }
	PaintImage();
	// scroll bars cause resizing which causes flicker
	// when invalidateRect method is used to redraw
	//	InvalidateRect(hWnd,NULL,TRUE);
	//	UpdateWindow(hWnd);
	break;
  case WM_PAINT:
	if (hWnd != MainWnd  ||  GetUpdateRect(hWnd,NULL,FALSE) == 0)
	  {
      return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	  break;
	  }
	PaintImage();
    return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	break;
  case WM_LBUTTONDOWN:case WM_RBUTTONDOWN:
    return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	break;
  case WM_MOUSEMOVE:
    return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	break;
  case WM_DESTROY:
    PostQuitMessage(0);
    break;
  default:
    return(DefWindowProc(hWnd,uMsg,wParam,lParam));
    break;
  }


return(0L);
}



void PaintImage()

{
PAINTSTRUCT	  Painter;
HDC			  hDC;
RECT		  PlotRect,TextRect;
HBRUSH		  DrawBrush;
SIZE		  TextSize;
char		  text[300];
int			  x,y,i,BarLevel,Max;
static int	  LastDisplayMode;

if (DisplayMode != LastDisplayMode)
  {		/* new display mode = clear window first */
  hDC=GetDC(MainWnd);
  PlotRect.top=0; PlotRect.bottom=1000; PlotRect.left=0; PlotRect.right=1300;
  DrawBrush=CreateSolidBrush(RGB(255,255,255));
  FillRect(hDC,&PlotRect,DrawBrush);
  DeleteObject(DrawBrush);
  ReleaseDC(MainWnd,hDC);
  LastDisplayMode=DisplayMode;
  }
if (DisplayMode == 1)
  {
  BeginPaint(MainWnd,&Painter);
  hDC=GetDC(MainWnd);
  DrawBrush=CreateSolidBrush(RGB(200,200,200));
		/* heart rate monitor window */
  y=PlotRect.top=TOP_WINDOW_MARGIN;
  PlotRect.bottom=y+HeartRateWindowRows;
  x=PlotRect.left=TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN;
  PlotRect.right=x+HeartRateWindowCols;
  FillRect(hDC,&PlotRect,DrawBrush);
  sprintf(text,"Heartbeats");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+HeartRateWindowCols/2-TextSize.cx/2,y-TextSize.cy,text,strlen(text));
  sprintf(text,"%d MPB",PlotDataMinValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y+HeartRateWindowRows-TextSize.cy,text,strlen(text));
  sprintf(text,"%d MPB",PlotDataMaxValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y,text,strlen(text));
  sprintf(text,"%d seconds",PlotDataRange);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+HeartRateWindowCols/2-TextSize.cx/2,y+HeartRateWindowRows,text,strlen(text));
		/* power window */
  y=PlotRect.top=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN;
  PlotRect.bottom=y+PowerWindowRows;
  x=PlotRect.left=TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN+HeartRateWindowCols/2-PowerWindowCols/2;
  PlotRect.right=x+PowerWindowCols;
  FillRect(hDC,&PlotRect,DrawBrush);
  sprintf(text,"Power");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+PowerWindowCols/2-TextSize.cx/2,y-TextSize.cy,text,strlen(text));
  sprintf(text,"%d",PowerDataMinValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y+PowerWindowRows-TextSize.cy,text,strlen(text));
  sprintf(text,"(MPB^2)/CPM");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y+PowerWindowRows/2-TextSize.cy,text,strlen(text));
  sprintf(text,"%d",PowerDataMaxValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y,text,strlen(text));
  sprintf(text,"%d CPM",PowerDataRange);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+PowerWindowCols/2-TextSize.cx/2,y+PowerWindowRows,text,strlen(text));
		/* RSA window */
  y=PlotRect.top=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN;
  PlotRect.bottom=y+RSAWindowRows;
  x=PlotRect.left=TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN+HeartRateWindowCols+SIDE_WINDOW_MARGIN;
  PlotRect.right=x+RSAWindowCols;
  FillRect(hDC,&PlotRect,DrawBrush);
  sprintf(text,"RSA");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+RSAWindowCols/2-TextSize.cx/2,y-TextSize.cy,text,strlen(text));
  sprintf(text,"%d",PowerDataMinValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y+PowerWindowRows-TextSize.cy,text,strlen(text));
  sprintf(text,"(MPB^2)/CPM");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y+PowerWindowRows/2-TextSize.cy,text,strlen(text));
  sprintf(text,"%d",PowerDataMaxValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y,text,strlen(text));
  sprintf(text,"%d seconds",RSADataRange);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+RSAWindowCols/2-TextSize.cx/2,y+RSAWindowRows,text,strlen(text));
		/* RSA long window */
  y=PlotRect.top=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+PowerWindowRows+TOP_WINDOW_MARGIN;
  PlotRect.bottom=y+RSALongWindowRows;
  x=PlotRect.left=TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN;
  PlotRect.right=x+RSALongWindowCols;
  FillRect(hDC,&PlotRect,DrawBrush);
  sprintf(text,"RSA (long-term)");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+RSALongWindowCols/2-TextSize.cx/2,y-TextSize.cy,text,strlen(text));
  sprintf(text,"%d",PowerDataMinValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y+RSALongWindowRows-TextSize.cy,text,strlen(text));
  sprintf(text,"(MPB^2)/CPM");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y+RSALongWindowRows/2-TextSize.cy,text,strlen(text));
  sprintf(text,"%d",PowerDataMaxValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x-TextSize.cx,y,text,strlen(text));
  sprintf(text,"%d minutes",RSALongDataRange);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+RSALongWindowCols/2-TextSize.cx/2,y+RSALongWindowRows,text,strlen(text));
  DeleteObject(DrawBrush);
		/* plot all RSA long data */
  for (i=0; i<RSALongWindowCols; i++)
	{
    if (RSALongPlot[i] == -1)
	  {
      y=PlotRect.top=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+RSAWindowRows+TOP_WINDOW_MARGIN;
      PlotRect.bottom=y+RSALongWindowRows;
      x=PlotRect.left=TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN+i;
      PlotRect.right=x+1;
      DrawBrush=CreateSolidBrush(RGB(200,200,200));
      FillRect(hDC,&PlotRect,DrawBrush);
      DeleteObject(DrawBrush);
	  continue;
	  }
    y=PlotRect.top=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+RSAWindowRows+TOP_WINDOW_MARGIN+RSALongWindowRows
				-(int)((double)(RSALongPlot[i]-PowerDataMinValue)/
				(double)(PowerDataMaxValue-PowerDataMinValue)*(double)RSALongWindowRows)-
				TICKMARK_THICKNESS/2;
    PlotRect.bottom=y+TICKMARK_THICKNESS;
    x=PlotRect.left=TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN+i;
    PlotRect.right=x+1;
	   /* check for clipping on window boundaries */
    if (PlotRect.right == PlotRect.left) PlotRect.right=PlotRect.left+1;
    if (PlotRect.right > TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN+RSALongWindowCols)
      PlotRect.right=TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN+RSALongWindowCols;
    if (PlotRect.top < TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+PowerWindowRows+TOP_WINDOW_MARGIN)
	  {
      PlotRect.top=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+PowerWindowRows+TOP_WINDOW_MARGIN;
	  PlotRect.bottom=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+PowerWindowRows+TOP_WINDOW_MARGIN+TICKMARK_THICKNESS/2;
	  }
    if (PlotRect.bottom > TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+RSAWindowRows+TOP_WINDOW_MARGIN+RSALongWindowRows)
	  {
      PlotRect.top=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+RSAWindowRows+TOP_WINDOW_MARGIN+RSALongWindowRows-TICKMARK_THICKNESS/2;
      PlotRect.bottom=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+RSAWindowRows+TOP_WINDOW_MARGIN+RSALongWindowRows;
	  }
    DrawBrush=CreateSolidBrush(RGB(100,200,100));
    FillRect(hDC,&PlotRect,DrawBrush);
    DeleteObject(DrawBrush);
	}

		/* histogram of arousal (normalized max-power) */
  x=PlotRect.left=10;
  y=PlotRect.top=TOP_WINDOW_MARGIN+HeartRateWindowRows+TOP_WINDOW_MARGIN+PowerWindowRows+TOP_WINDOW_MARGIN;
  PlotRect.right=x+NormWindowCols;
  PlotRect.bottom=y+NormWindowRows;
  DrawBrush=CreateSolidBrush(RGB(200,200,200));
  FillRect(hDC,&PlotRect,DrawBrush);
  DeleteObject(DrawBrush);
  sprintf(text,"Log-Norm Dist");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+NormWindowCols/2-TextSize.cx/2,y-TextSize.cy,text,strlen(text));
  sprintf(text,"%d",NormDistMinValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x,y+NormWindowRows,text,strlen(text));
  sprintf(text,"%d",NormDistMaxValue);
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,x+NormWindowCols-TextSize.cx,y+NormWindowRows,text,strlen(text));
  DrawBrush=CreateSolidBrush(RGB(0,255,0));
  Max=0;
  for (i=1; i<1000; i++)
	if (NormHist[i] > NormHist[Max])
	  Max=i;
  for (i=0; i<1000; i++)
	{
	if (NormHist[i] == 0)
	  BarLevel=0;
	else
	  BarLevel=(int)(((double)NormHist[i]/(double)NormHist[Max])*(double)NormWindowRows);
	PlotRect.left=x+(int)((double)i/1000.0*(double)NormWindowCols);
	PlotRect.right=PlotRect.left+1;
	PlotRect.bottom=y+NormWindowRows;
	PlotRect.top=PlotRect.bottom-BarLevel;
    FillRect(hDC,&PlotRect,DrawBrush);
	}
  DeleteObject(DrawBrush);

		/* ameter gauge display */
  y=PlotRect.top=TOP_WINDOW_MARGIN+HeartRateWindowRows-GAUGE_RADIUS;
  PlotRect.bottom=y+GAUGE_RADIUS*2;
  x=PlotRect.left=TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN+HeartRateWindowCols+SIDE_WINDOW_MARGIN+RSAWindowCols/2-GAUGE_RADIUS;
  PlotRect.right=x+GAUGE_RADIUS*2;
  Pie(hDC,x,y,x+GAUGE_RADIUS*2,y+GAUGE_RADIUS*2, x+GAUGE_RADIUS*2,y+GAUGE_RADIUS,x,y+GAUGE_RADIUS);
		/* variables text output */
  y=PlotRect.top=TOP_WINDOW_MARGIN;
  PlotRect.bottom=y+HeartRateWindowRows+TOP_WINDOW_MARGIN+PowerWindowRows+TOP_WINDOW_MARGIN/2;
  x=PlotRect.left=10;
  PlotRect.right=TEXT_DISPLAY_WIDTH;
  DrawBrush=CreateSolidBrush(RGB(255,255,255));
  FillRect(hDC,&PlotRect,DrawBrush);
  DeleteObject(DrawBrush);
  sprintf(text,"Sampling rate (Hz): %d",SamplingRate);
  TextOut(hDC,x,y+10,text,strlen(text));
  sprintf(text,"Window (seconds): %d",WindowSec);
  TextOut(hDC,x,y+30,text,strlen(text));
  sprintf(text,"Window (samples): %d",WindowSize);
  TextOut(hDC,x,y+50,text,strlen(text));
  sprintf(text,"Arousal smoothing: %6.3lf",ArousalSmooth);
  TextOut(hDC,x,y+70,text,strlen(text));
  sprintf(text,"Z-range (std devs): %3.1lf",ZScoreRange);
  TextOut(hDC,x,y+90,text,strlen(text));
  sprintf(text,"RSA mean: %5.1lf",MeanRSA);
  TextOut(hDC,x,y+110,text,strlen(text));
  sprintf(text,"RSA std dev: %5.1lf",StdDevRSA);
  TextOut(hDC,x,y+130,text,strlen(text));
  sprintf(text,"RSA current: %5.1lf",0.0);
  TextOut(hDC,x,y+150,text,strlen(text));
  sprintf(text,"Total minutes: %d",TotalMinutes);
  TextOut(hDC,x,y+170,text,strlen(text));
  ReleaseDC(MainWnd,hDC);
  EndPaint(MainWnd,&Painter);
  }

		/* display timer and RSA statistics */
if (DisplayMode == 1  ||  DisplayMode == 0)
  {
  hDC=GetDC(MainWnd);
  y=TextRect.top=60;
  TextRect.bottom=y+20;
  x=TextRect.left=TEXT_DISPLAY_WIDTH+SIDE_WINDOW_MARGIN+HeartRateWindowCols+SIDE_WINDOW_MARGIN;
  TextRect.right=x+RSAWindowCols;
  DrawBrush=CreateSolidBrush(RGB(255,255,255));
  FillRect(hDC,&TextRect,DrawBrush);
  DeleteObject(DrawBrush);
  x=10;
  y=TOP_WINDOW_MARGIN;
  sprintf(text,"RSA mean: %5.1lf   ",MeanRSA);
  TextOut(hDC,x,y+110,text,strlen(text));
  sprintf(text,"RSA std dev: %5.1lf   ",StdDevRSA);
  TextOut(hDC,x,y+130,text,strlen(text));
  sprintf(text,"Total minutes: %d   ",TotalMinutes);
  TextOut(hDC,x,y+170,text,strlen(text));
  ReleaseDC(MainWnd,hDC);
  }

if (DisplayMode == 4)
  {
  hDC=GetDC(MainWnd);
  y=TextRect.top=100;
  TextRect.bottom=y+300;
  x=TextRect.left=100;
  TextRect.right=x+1000;
  DrawBrush=CreateSolidBrush(RGB(200,200,200));
  FillRect(hDC,&TextRect,DrawBrush);
  y=TextRect.top=500;
  TextRect.bottom=y+300;
  FillRect(hDC,&TextRect,DrawBrush);
  DeleteObject(DrawBrush);
  sprintf(text,"Heartrate");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,100+1000/2-TextSize.cx/2,100-TextSize.cy,text,strlen(text));
  sprintf(text,"Heartrate variability (RSA)");
  GetTextExtentPoint32(hDC,text,strlen(text),&TextSize);
  TextOut(hDC,100+1000/2-TextSize.cx/2,500-TextSize.cy,text,strlen(text));
  ReleaseDC(MainWnd,hDC);
  }

}

