
#include <stdio.h>
#include "globals.h"


static FILE	*fpt;
static int	FileDataType;	  /* 0 => aIBI only */
							  /* 1 => commented file with aIBI only */
							  /* 2 => Ameter version 2.0 and later */
static int	NextData;		  /* impending data (already read from file, waiting on Time) */
static int	NextTimeStamp;	  /* when Time catches up to NextSnycTime, then data is given */
static int	NextSyncTime;	  /* and next data is read from file, becoming impending data */
static int	TimeRemaining;	  /* when not using TimeStamps, this variable used to countdown IBI for playback */


void SetUpPlayback()

{
int					  i;
char				  header[1000];

		/* open file for reading data */
if ((fpt=fopen(PlaybackFilename,"rb")) == NULL)
  {
  MessageBox(NULL,"Unable to open file for playback",PlaybackFilename,MB_OK | MB_APPLMODAL);
  MonitorOn=0;
  return;
  }
		/* read header (first whole line to carriage return) */
header[0]=fgetc(fpt);
if (header[0] == '#')
  {
  i=1;
  while (i < 1000)
	{
    header[i]=fgetc(fpt);
    if (header[i] == EOF)
	  {
	  header[i-1]='\0';
      break;
	  }
    if (header[i] == '\n')
	  {
	  header[i]='\0';
	  break;
	  }
    i++;
	}
  if (strncmp(header,"# AMeter Version 2.0 raw aIBI data",34) == 0  ||	/* oops, had stupid scheme on 2.0 */
	  strncmp(header,"# AMeter raw aIBI data",22) == 0)	  /* better scheme - have version at end of line */
	FileDataType=2;	/* aIBI's with timestamps, burn off rest of comments */
  else
	{
	FileDataType=1;	/* has comments but wrong header - assume this is a mistake */
	}
  }
else
  {
  fseek(fpt,0,SEEK_SET);  /* move fpt back to beginning of file */
  FileDataType=0;	/* assume aIBI's only, no timestamps, nothing else in file */
  }
if (FileDataType == 1)
  {
  MessageBox(NULL,"Wrong header in file - not raw aIBI data file?",PlaybackFilename,MB_OK | MB_APPLMODAL);
  MonitorOn=0;
  return;
  }
		/* burn off all comment lines */
if (FileDataType > 0)
  {
  while (1)
	{
    header[0]=fgetc(fpt);
    if (header[0] == '#')
	  {
	  i=0;
      while (i < 1000)
		{
        header[1]=fgetc(fpt);
	    if (header[1] == EOF  ||  header[1] == '\n')
		  break;
        i++;
		}
	  }
    else
	  break;
	}
  }

		/* for reading data, and for buffer correcting rules */
if (FileDataType == 2)
  UseTimeStamps=1;
else
  UseTimeStamps=0;

if (UseTimeStamps == 1)
  {
  i=fscanf(fpt,"%d %d %d",&NextSyncTime,&NextTimeStamp,&NextData);
  if (i != 3)
	{
    MessageBox(NULL,"File is empty of data",PlaybackFilename,MB_OK | MB_APPLMODAL);
    MonitorOn=0;
    return;
	}
  }
else
  {
  i=fscanf(fpt,"%d",&NextData);
  NextTimeStamp=NextSyncTime=0;
  TimeRemaining=NextData;
  if (i != 1)
	{
    MessageBox(NULL,"File is empty of data",PlaybackFilename,MB_OK | MB_APPLMODAL);
    MonitorOn=0;
    return;
	}
  }

}




int CheckPlayback(unsigned long int Time)

{
int	  i;

		/* wait for Time to catch up to NextSyncTime, which is when next data should be given */
if (UseTimeStamps == 1  &&  (int)Time < NextSyncTime)
  return(0);
if (UseTimeStamps == 0)
  {
  TimeRemaining-=(1000/SamplingRate);
  if (TimeRemaining > 0)
	return(0);
  }

		/* give next data (was previously read from file and stored in these variables */
new_aIBI_value=NextData;
new_aIBI_timestamp=NextTimeStamp;
new_aIBI_flag=1;

		/* read next data, buffering for NextSyncTime */
if (UseTimeStamps == 1)
  {
  i=fscanf(fpt,"%d %d %d",&NextSyncTime,&NextTimeStamp,&NextData);
  if (i != 3)
	{
    MonitorOn=0;
    return(0);
	}
  }
else
  {
  i=fscanf(fpt,"%d",&NextData);
  NextTimeStamp=NextSyncTime=0;
  TimeRemaining+=NextData;
  if (i != 1)
	{
    MonitorOn=0;
    return(0);
	}
  }
return(1);
}



void ClosePlayback()

{
fclose(fpt);
}






